<?php
define ( 'ABSPATH', dirname(__FILE__).'/' );
define ( 'INFLECT_CACHE', ABSPATH . 'cache/inflect.%s.txt' );
 
function inflector ( $name ) {
 
    // Getting Cachable ID
    $nid = md5( $name );
 
    // Checking for Cached Version
    if ( file_exists(sprintf(INFLECT_CACHE, $nid)) ) {
 
        // Loading form Cache
        $cases = file_get_contents( sprintf(INFLECT_CACHE, $nid) );
        $cases = unserialize( $cases );
        return $cases;
 
    } else {
 
        // Building Request URL
        $url = 'http://export.yandex.ru/inflect.xml?name='.urlencode($name);
 
        // Processing CURL Request
        $curl = curl_init( $url );
        curl_setopt( $curl, CURLOPT_USERAGENT, 'Opera/9.80 (Windows NT 6.1; U; ru) Presto/2.6.30 Version/10.61' ); // Just for fun, or ...
        curl_setopt( $curl, CURLOPT_RETURNTRANSFER, 1 );
        $result = curl_exec( $curl );
        curl_close( $curl );
 
        // Preparing Inflections
        $cases = array ();
        preg_match_all( '#\<inflection\s+case\=\"([0-9]+)\"\>(.*?)\<\/inflection\>#si', $result, $m );
 
        // Creating Inflection List
        if ( count($m[0]) ) {
            foreach ( $m[1] as $i => &$id ) {
                $cases[ (int) $id ] = $m[2][$i];
            } unset ( $id );
        } else return false;
 
        // Saving Result and Sending back to User
        file_put_contents( sprintf(INFLECT_CACHE, $nid), serialize($cases) );
        return $cases;
 
    }
 
}